"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .sourceaccountv2 import SourceAccountV2, SourceAccountV2TypedDict
from codat_bankfeeds.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
import pydantic
from pydantic import model_serializer
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class SourceAccountV2BatchCreateResultTypedDict(TypedDict):
    r"""Status details and corresponding object of the `Create account` operation."""

    account: NotRequired[SourceAccountV2TypedDict]
    r"""The target bank account in a supported accounting software for ingestion into a bank feed."""
    error: NotRequired[Nullable[str]]
    r"""A brief description of the error."""
    status_code: NotRequired[int]
    r"""The HTTP status code for the creation of the source account"""


class SourceAccountV2BatchCreateResult(BaseModel):
    r"""Status details and corresponding object of the `Create account` operation."""

    account: Optional[SourceAccountV2] = None
    r"""The target bank account in a supported accounting software for ingestion into a bank feed."""

    error: OptionalNullable[str] = UNSET
    r"""A brief description of the error."""

    status_code: Annotated[Optional[int], pydantic.Field(alias="statusCode")] = None
    r"""The HTTP status code for the creation of the source account"""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["account", "error", "statusCode"]
        nullable_fields = ["error"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
